var axios = require("axios");
var userUtil = require("user-util-vkm");
var cookie = require("js-cookie")

var userEntity = null;

var vkaxios = null;

function fresh() {
  userEntity = userUtil.getEntity();

  if(vkaxios == null)
  {
    vkaxios = axios.create({});
  }

  vkaxios.defaults.headers = {
    "Authorization": "management " + ( userEntity ? userEntity.id : "" ) + " " + ( userEntity ? userEntity.token : "" )
  }

  vkaxios.defaults.baseURL = CONFIG.pathPrefix;
};

fresh();

function preAction(res) {

  var data = res.data;

  var cookieSsoSyncSt = cookie.get('sso_sync_st');
  var localStorageSsoSyncSt = localStorage.getItem('sso_sync_st');
  if(CONFIG.sso)
  {
    if(cookieSsoSyncSt != localStorageSsoSyncSt)
    {
      location.href = CONFIG.ssoDomain + '/user/login?redirect_url=' + encodeURIComponent(location.href);
    }
  }

  if(data.hasOwnProperty("code") == false)
  {
    app_m.$message({
      message: "服务返回的数据格式错误",
      type: 'error'
    });
    return Promise.reject(res.data);
  }

  data.code = parseInt(data.code);

  switch(data.code)
  {
    case 20003:
      if(CONFIG.sso)
      {
        localStorage.removeItem("user");
        localStorage.removeItem("ssoToken")
        location.href = CONFIG.pathPrefix + '/user/login?redirect_url=' + encodeURIComponent(location.href);
      }
      else
      {
        userUtil.logout(false, location.href);
      }
    break;
    //兼容m-cs
    case 3:
      if(data.msg && data.msg.length > 0)
      {
        app_m.$message({
          message: data.msg,
          type: 'info'
        });
        return Promise.reject(res.data)
      }
      break;

  }


  return Promise.resolve(res.data);

};

vkaxios.interceptors.response.use(function (res) {
  return preAction.call(this, res);

}, function (e) {

  return preAction.call(this, e.response);

});


/**
 * 创建一个axios实例
 * @param {string} path - 路径前缀
 * @author lihaibo <lihaibo@vipkid.com.cn>
 */
function createApi(path) {
  var obj = axios.create({
    baseURL: path ? path : CONFIG.pathPrefix
  });

  userEntity = userUtil.getEntity();

  obj.defaults.headers = {
    "Authorization": "management " + ( userEntity ? userEntity.id : "" ) + " " + ( userEntity ? userEntity.token : "" )
  }

  obj.interceptors.response.use(function (res) {
    return preAction.call(this, res);
  }, function (e) {
    return preAction.call(this, e.response);
  });

  return obj;
}


module.exports = {
  fresh: fresh,

  axios: axios.create({ //定制axios

    headers: {
      "Authorization": "management " + ( userEntity ? userEntity.id : "" ) + " " + ( userEntity ? userEntity.token : "" )
    },

    baseURL: CONFIG.pathPrefix

  }),  //默认axios

  xhr: vkaxios,

  createApi: createApi
};
